#!/usr/bin/perl

# Double squarawave music with PWM played on the STAF.
# transpose.pl
# a tool to transpose one of the channels
# 
# 15.08.2016
# Copyright (C) 2014-2016  Balthasar Szczepański
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# A tool to change the pitch of one of the channels in sheet.h by a selected
# number of halftones.
# usage:
# transpose.pl offset channel <inputfile >outputfile
# offset - the number of halftones to change, positive increases frequency.
# channel - which channel to modify (1 or 2)

my $offset=int($ARGV[0]);
my $sheet =int($ARGV[1]);
my $active=0;

sub transpose {
	(my $name, my $octave) = @_;
	my $index;
	
	$index = 12 * $octave;
	if ($name eq "HH") {
		$index += 11;
	}elsif ($name eq "AH") {
		$index += 10;
	}elsif ($name eq "AA") {
		$index += 9;
	}elsif ($name eq "GA") {
		$index += 8;
	}elsif ($name eq "GG") {
		$index += 7;
	}elsif ($name eq "FG") {
		$index += 6;
	}elsif ($name eq "FF") {
		$index += 5;
	}elsif ($name eq "EE") {
		$index += 4;
	}elsif ($name eq "DE") {
		$index += 3;
	}elsif ($name eq "DD") {
		$index += 2;
	}elsif ($name eq "CD") {
		$index += 1;
	}elsif ($name eq "CC") {
		$index += 0;
	}else {
		return "EEE";
	}
	
	$index += $offset;
	
	$octave = int($index / 12);
	$index = $index % 12;
	
	
	if ($index == 11) {
		$name = "HH";
	}elsif ($index == 10) {
		$name = "AH";
	}elsif ($index ==  9) {
		$name = "AA";
	}elsif ($index ==  8) {
		$name = "GA";
	}elsif ($index ==  7) {
		$name = "GG";
	}elsif ($index ==  6) {
		$name = "FG";
	}elsif ($index ==  5) {
		$name = "FF";
	}elsif ($index ==  4) {
		$name = "EE";
	}elsif ($index ==  3) {
		$name = "DE";
	}elsif ($index ==  2) {
		$name = "DD";
	}elsif ($index ==  1) {
		$name = "CD";
	}elsif ($index ==  0) {
		$name = "CC";
	}else {
		return "FFF";
	}
	return $name.$octave;
}

while (defined(my $line = <STDIN>)) {
	
	if($line =~ /sheet([0-9]+)/) {
		if($1 eq $sheet) {
			$active = 1;
		}
		else {
			$active = 0;
		}
	}
	if ($active) {
		$line =~ s/([A-Z][A-Z])([0-9])/transpose($1,$2)/ge;
	}
	print ($line);
}
